# swagger
This is a sample Petstore server.  You can find out more about Swagger at [http://swagger.io](http://swagger.io) or on [irc.freenode.net, #swagger](http://swagger.io/irc/). 

This Dart package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.dart.DartClientCodegen

## Requirements

Dart 1.20.0 or later OR Flutter 0.0.20 or later

## Installation & Usage

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```
name: swagger
version: 1.0.0
description: Swagger API client
dependencies:
  swagger:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
      version: 'any'
```

### Local
To use the package in your local drive, please include the following in pubspec.yaml
```
dependencies:
  swagger:
    path: /path/to/swagger
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:swagger/api.dart';

var api_instance = new DefaultApi();

try {
    var result = api_instance.testMethod();
    print(result);
} catch (e) {
    print("Exception when calling DefaultApi->testMethod: $e\n");
}
```

## Documentation for API Endpoints

All URIs are relative to */*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**testMethod**](docs//DefaultApi.md#testmethod) | **GET** /test | 
*PetApi* | [**addPet**](docs//PetApi.md#addpet) | **POST** /pet | Add a new pet to the store
*PetApi* | [**deletePet**](docs//PetApi.md#deletepet) | **DELETE** /pet/{petId} | Deletes a pet
*PetApi* | [**doCategoryStuff**](docs//PetApi.md#docategorystuff) | **POST** /pet/category | 
*PetApi* | [**findPetsByStatus**](docs//PetApi.md#findpetsbystatus) | **GET** /pet/findByStatus | Finds Pets by status
*PetApi* | [**findPetsByTags**](docs//PetApi.md#findpetsbytags) | **GET** /pet/findByTags | Finds Pets by tags
*PetApi* | [**getAllPets**](docs//PetApi.md#getallpets) | **GET** /allPets | 
*PetApi* | [**getPetById**](docs//PetApi.md#getpetbyid) | **GET** /pet/{petId} | Find pet by ID
*PetApi* | [**getRandomPet**](docs//PetApi.md#getrandompet) | **GET** /randomPet | 
*PetApi* | [**updatePet**](docs//PetApi.md#updatepet) | **PUT** /pet | Update an existing pet
*PetApi* | [**updatePetWithForm**](docs//PetApi.md#updatepetwithform) | **POST** /pet/{petId} | Updates a pet in the store with form data
*PetApi* | [**uploadFile**](docs//PetApi.md#uploadfile) | **POST** /pet/{petId}/uploadImage | uploads an image
*StoreApi* | [**deleteOrder**](docs//StoreApi.md#deleteorder) | **DELETE** /store/order/{orderId} | Delete purchase order by ID
*StoreApi* | [**getInventory**](docs//StoreApi.md#getinventory) | **GET** /store/inventory | Returns pet inventories by status
*StoreApi* | [**getOrderById**](docs//StoreApi.md#getorderbyid) | **GET** /store/order/{orderId} | Find purchase order by ID
*StoreApi* | [**placeOrder**](docs//StoreApi.md#placeorder) | **POST** /store/order | Place an order for a pet
*UserApi* | [**createUser**](docs//UserApi.md#createuser) | **POST** /user | Create user
*UserApi* | [**createUsersWithArrayInput**](docs//UserApi.md#createuserswitharrayinput) | **POST** /user/createWithArray | Creates list of users with given input array
*UserApi* | [**createUsersWithListInput**](docs//UserApi.md#createuserswithlistinput) | **POST** /user/createWithList | Creates list of users with given input array
*UserApi* | [**deleteUser**](docs//UserApi.md#deleteuser) | **DELETE** /user/{username} | Delete user
*UserApi* | [**getUserByName**](docs//UserApi.md#getuserbyname) | **GET** /user/{username} | Get user by user name
*UserApi* | [**loginUser**](docs//UserApi.md#loginuser) | **GET** /user/login | Logs user into the system
*UserApi* | [**logoutUser**](docs//UserApi.md#logoutuser) | **GET** /user/logout | Logs out current logged in user session
*UserApi* | [**userUsernamePut**](docs//UserApi.md#userusernameput) | **PUT** /user/{username} | Updated user

## Documentation For Models

 - [AllOfSubCategoryCategory](docs//AllOfSubCategoryCategory.md)
 - [AllPetsResponse](docs//AllPetsResponse.md)
 - [ApiResponse](docs//ApiResponse.md)
 - [Body](docs//Body.md)
 - [Cat](docs//Cat.md)
 - [CatAllOf2](docs//CatAllOf2.md)
 - [Category](docs//Category.md)
 - [Dog](docs//Dog.md)
 - [DogAllOf2](docs//DogAllOf2.md)
 - [InlineArrayItemsAllPetsResponse](docs//InlineArrayItemsAllPetsResponse.md)
 - [NullableEnumModel](docs//NullableEnumModel.md)
 - [OneOfSinglePetResponsePet](docs//OneOfSinglePetResponsePet.md)
 - [OneOfinlineArrayItemsAllPetsResponse](docs//OneOfinlineArrayItemsAllPetsResponse.md)
 - [Order](docs//Order.md)
 - [Pet](docs//Pet.md)
 - [SinglePetResponse](docs//SinglePetResponse.md)
 - [SubCategory](docs//SubCategory.md)
 - [SubCategoryPets](docs//SubCategoryPets.md)
 - [Tag](docs//Tag.md)
 - [Test](docs//Test.md)
 - [User](docs//User.md)

## Documentation For Authorization


## api_key

- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header

## bearer


## petstore_auth

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: http://petstore.swagger.io/oauth/dialog
- **Scopes**: 
 - ****: 


## Author

apiteam@swagger.io
